unit im_coloradjFRM;

{*********************************************}
{  This unit is a part of ImageE              }
{  Copyright  2003-2004 R.Geurts             }
{  See Readme.txt for licence information     }
{*********************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls,
  gr32,im_effects,im_childwin,math, GR32_Image;

type
  TcoloradjCTRLForm = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TrackBar1: TTrackBar;
    Edit1: TEdit;
    TrackBar2: TTrackBar;
    Edit2: TEdit;
    TrackBar3: TTrackBar;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    TrackBar4: TTrackBar;
    Edit4: TEdit;
    Edit5: TEdit;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    Edit6: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    HelpBtn: TSpeedButton;
    procedure TrackBar1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure TrackBar6Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
  src:tbitmap32;
  dst:tbitmap32;
  srcrect,dstrect:trect;
  end;

var
  ColorAdjCTRLForm: TColorAdjCTRLForm;

implementation

uses im_D5, im_MainFrm;
{$R *.dfm}

procedure TcoloradjCTRLForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  coloradjCTRLFormX := coloradjCTRLForm.left;
  coloradjCTRLFormY:= coloradjCTRLForm.top;
end;

procedure TColorAdjCTRLForm.FormCreate(Sender: TObject);
begin
  left := coloradjCTRLFormX;
  top := coloradjCTRLFormY;
  dst:=TBitmap32.Create;
  src:=TBitmap32.Create;
end;


procedure TColorAdjCTRLForm.FormShow(Sender: TObject);
begin
   src.Assign(dst);
   trackbar1.Min:=-255;
   trackbar1.Max:=255;
   trackbar1.Position:=0;
   trackbar1.Frequency:=10;
   trackbar2.Min:=-255;
   trackbar2.Max:=255;
   trackbar2.Position:=0;
   trackbar2.Frequency:=10;
   trackbar3.Min:=-255;
   trackbar3.Max:=255;
   trackbar3.Position:=0;
   trackbar3.Frequency:=10;

   trackbar4.Min:=-255;
   trackbar4.Max:=255;
   trackbar4.Position:=0;
   trackbar4.Frequency:=10;
   trackbar5.Min:=-255;
   trackbar5.Max:=255;
   trackbar5.Position:=0;
   trackbar5.Frequency:=10;
   trackbar6.Min:=-255;
   trackbar6.Max:=255;
   trackbar6.Position:=0;
   trackbar6.Frequency:=10;
end;


procedure TColorAdjCTRLForm.TrackBar1Change(Sender: TObject);
begin
  dst.Assign(src);
  edit1.text:=floattostr(trackbar1.position);
  edit2.text:=floattostr(trackbar2.position);
  edit3.text:=floattostr(trackbar3.position);

  Effect_incdecRGB(dst,trackbar1.position,trackbar2.position,trackbar3.position);

  with MainForm.ActiveMDIChild as TMdiChild do begin
   if selectionactive=true then
   imageview1.Bitmap.Draw(srcrect,dstrect,dst)
   else
   imageview1.Bitmap.Assign(dst);
   Imageview1.Repaint;
  end;

end;


procedure TColorAdjCTRLForm.Edit1Change(Sender: TObject);
begin
 trackbar1.Position:=ensurerangeiiii(strtointdef(edit1.text,0),trackbar1.min,trackbar1.max);
end;

procedure TcoloradjCTRLForm.Edit2Change(Sender: TObject);
begin
 trackbar2.Position:=ensurerangeiiii(strtointdef(edit2.text,0),trackbar2.min,trackbar2.max);
end;

procedure TcoloradjCTRLForm.Edit3Change(Sender: TObject);
begin
 trackbar3.Position:=ensurerangeiiii(strtointdef(edit3.text,0),trackbar3.min,trackbar3.max);
end;

procedure TcoloradjCTRLForm.TrackBar6Change(Sender: TObject);
begin
  dst.Assign(src);
  edit4.text:=floattostr(trackbar4.position);
  edit5.text:=floattostr(trackbar5.position);
  edit6.text:=floattostr(trackbar6.position);

  Effect_incdecHSL(dst,trackbar6.position,trackbar5.position,trackbar4.position);

  with MainForm.ActiveMDIChild as TMdiChild do begin
   if selectionactive=true then
   imageview1.Bitmap.Draw(srcrect,dstrect,dst)
   else
   imageview1.Bitmap.Assign(dst);
   Imageview1.Repaint;
  end;
end;

procedure TcoloradjCTRLForm.Edit6Change(Sender: TObject);
begin
 trackbar4.Position:=ensurerangeiiii(strtointdef(edit4.text,0),trackbar4.min,trackbar4.max);
end;

procedure TcoloradjCTRLForm.Edit5Change(Sender: TObject);
begin
 trackbar5.Position:=ensurerangeiiii(strtointdef(edit5.text,0),trackbar5.min,trackbar5.max);
end;

procedure TcoloradjCTRLForm.Edit4Change(Sender: TObject);
begin
 trackbar6.Position:=ensurerangeiiii(strtointdef(edit6.text,0),trackbar6.min,trackbar6.max);
end;





procedure TcoloradjCTRLForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8000);
end;

end.
