unit im_defselectionFRM;

{*********************************************}
{  This unit is a part of ImageE              }
{  Copyright  2003-2004 R.Geurts             }
{  See Readme.txt for licence information     }
{*********************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls,im_childwin;

type
  TSelectionForm = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    UpDown3: TUpDown;
    UpDown4: TUpDown;
    Label7: TLabel;
    Label8: TLabel;
    BitBtn1: TBitBtn;
    HelpBtn: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure UpDown1Changing(Sender: TObject; var AllowChange: Boolean);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
  private
    procedure SelectionUpdate;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SelectionForm: TSelectionForm;
  origx,origy,selx,sely:integer;

implementation

uses im_D5, im_MainFrm;

{$R *.dfm}

procedure TSelectionForm.FormCreate(Sender: TObject);
begin
  left := SelectionFormX;
  top := SelectionFormY;
end;

procedure TSelectionForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  SelectionFormX := SelectionForm.left;
  SelectionFormY:= SelectionForm.top;
end;

procedure TSelectionForm.FormShow(Sender: TObject);
var imwidth,imheight:integer;

begin
  with MainForm.ActiveMDIChild as TMdiChild do begin
  imwidth:=Imageview1.Bitmap.Width;
  imheight:=Imageview1.Bitmap.Height;

  label7.caption:=inttostr(imwidth);
  label8.caption:=inttostr(imheight);

  edit1.text:=inttostr(round(imwidth/4));
  edit2.text:=inttostr(round(imheight/4));
  edit3.text:=inttostr(round(imwidth/2));
  edit4.text:=inttostr(round(imheight/2));
  end;

  updown1.Min:=0;
  updown2.Min:=0;
  updown3.Min:=0;
  updown4.Min:=0;

  updown1.Max:=imwidth;
  updown2.Max:=imHeight;
  updown3.Max:=imwidth;
  updown4.Max:=imHeight;

  Selectionupdate;
end;

procedure TselectionForm.SelectionUpdate;
begin
  origx:=strtointdef(edit1.text,0);
  origy:=strtointdef(edit2.text,0);
  selx:=origx+strtointdef(edit3.text,0)-1;
  sely:=origy+strtointdef(edit4.text,0)-1;
  with MainForm.ActiveMDIChild as TMdiChild do begin
  MainForm.Select(origx,origy,selx,sely);
  end;
end;

procedure TSelectionForm.UpDown1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  Selectionupdate;
end;

procedure TSelectionForm.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key<>chr(13) then exit;
  if edit1.text=''then exit;
  if edit2.text=''then exit;
  if edit3.text=''then exit;
  if edit4.text=''then exit;
  SelectionUpdate;
end;

procedure TSelectionForm.BitBtn1Click(Sender: TObject);
begin
selectionupdate;
end;



procedure TSelectionForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(6000);
end;

end.
